피벗 테이블 레이아웃

SpreadJS 피벗 테이블에서는 압축 형식, 개요 형식 및 표 형식, 이렇게 3가지 종류의 레이아웃을 제공합니다. 레이아웃이 어떻게 바뀌는지 보기 위해 아래 데모에서 드롭다운 메뉴를 사용하여 레이아웃을 변경해 보십시오.

설명
app.js
index.html
styles.css

피벗 테이블에는 다음과 같이 3가지 레이아웃이 있습니다.

  • 압축 형식
  • 개요 형식
  • 표 형식

기본 레이아웃은 압축 형식입니다.

각 레이아웃 유형에 대한 설명은 다음과 같습니다.

압축 형식

1.행 레이블

  • 압축 형식에서 각 행 레이블은 별도의 행에 있습니다.
  • 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다.
  • 각 행 레이블은 필드와 구분하기 위해 위에 있는 필드보다 약간 들여쓰기됩니다.
  • 행 레이블은 반복할 수 없습니다.
  • 들여쓰기는 레이아웃 및 서식 탭의 피벗 테이블 옵션에서 변경할 수 있습니다.

2.행 필드

  • 압축 형식에서 모든 행 필드는 단일 열에 있습니다.
  • 행 필드 열에는 일반 제목인 행 레이블이 있습니다.

3.부분합

  • 압축 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다.
  • 이 설정은 모든 행 필드에 영향을 미칩니다.
  • 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다.
  • 부분합이 맨 아래에 표시되더라도 행 레이블은 맨 위에 있습니다.

개요 형식

1.행 레이블

  • 개요 형식에서 각 행 레이블은 별도의 행에 있습니다.
  • 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다.
  • 행 레이블은 반복할 수 있습니다.

2.행 필드

  • 개요 형식에서 각 행 필드는 별도의 열에 있습니다.
  • 각 행 필드의 이름은 열 제목에 표시됩니다.

3.부분합

  • 개요 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다.
  • 이 설정은 모든 행 필드에 영향을 미칩니다.
  • 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다.

표 형식

1.행 레이블

  • 표 형식에서 외부 필드에 대한 행 레이블은 관련 내부 필드에 대한 첫 번째 레이블과 동일한 행에 있습니다.
  • 행 레이블은 반복할 수 있습니다.

2.행 필드

  • 표 형식에서 각 행 필드는 별도의 열에 있습니다.
  • 각 행 필드의 이름은 열 제목에 표시됩니다.

3.부분합

  • 표 형식에서 부분합은 각 그룹의 맨 위에만 표시할 수 있습니다.
  • 이 설정은 모든 행 필드에 영향을 미칩니다.
  • 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다.

사용자는 피벗 테이블의 레이아웃 유형을 가져와 설정할 수 있습니다.

///* function layoutType (type?: GC.Spread.Pivot.PivotTableLayoutType)
/**
 * @description get or set the layoutType of the PivotTable
 * @param {GC.Spread.Pivot.PivotTableLayoutType} type Pivot TableLayout Type
 */
layoutType (type?: PivotTableLayoutType): PivotTableLayoutType | void ;

PivotTableLayoutType은 아래와 같이 정의된 열거입니다.

///* enum GC.Spread.Pivot.PivotTableLayoutType
/**
 * represents the view type of pivot
 * @enum {number}
 */
enum PivotTableLayoutType {
    /**
     * compact view
     */
    compact = 0,
    /**
     * outline view
     */
    outline = 1,
    /**
     * tabular view
     */
    tabular = 2
}
피벗 테이블에는 다음과 같이 3가지 레이아웃이 있습니다. 압축 형식 개요 형식 표 형식 기본 레이아웃은 압축 형식입니다. 각 레이아웃 유형에 대한 설명은 다음과 같습니다. 압축 형식 1.행 레이블 압축 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 각 행 레이블은 필드와 구분하기 위해 위에 있는 필드보다 약간 들여쓰기됩니다. 행 레이블은 반복할 수 없습니다. 들여쓰기는 레이아웃 및 서식 탭의 피벗 테이블 옵션에서 변경할 수 있습니다. 2.행 필드 압축 형식에서 모든 행 필드는 단일 열에 있습니다. 행 필드 열에는 일반 제목인 행 레이블이 있습니다. 3.부분합 압축 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 부분합이 맨 아래에 표시되더라도 행 레이블은 맨 위에 있습니다. 개요 형식 1.행 레이블 개요 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 개요 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 개요 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 표 형식 1.행 레이블 표 형식에서 외부 필드에 대한 행 레이블은 관련 내부 필드에 대한 첫 번째 레이블과 동일한 행에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 표 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 표 형식에서 부분합은 각 그룹의 맨 위에만 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 사용자는 피벗 테이블의 레이아웃 유형을 가져와 설정할 수 있습니다. PivotTableLayoutType은 아래와 같이 정의된 열거입니다.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 }); initSpread(spread); var pivotLayoutSheet = spread.getSheet(0); var pt = initPivotTable(pivotLayoutSheet); bindEvent(spread, pt); }; function initSpread(spread) { spread.suspendPaint(); var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); } function initPivotTable(sheet) { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("분기 (date)", "분기 (date)", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc }); let style = new GC.Spread.Sheets.Style(); style.formatter = "$ #,##0"; myPivotTable.setStyle({dataOnly: true}, style); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); return myPivotTable; } function bindEvent (spread, pt) { _getElementById("layoutType").addEventListener("change", () => { if (spread) { var type = parseInt(document.getElementById("layoutType").value, 10); pt.layoutType(type); pt.autoFitColumn(); } }); } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta name="spreadjs culture" content="ko-kr"/> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-resources-ko/dist/gc.spread.sheets.resources.ko.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <label><b>Pivot Layout</b> </label></div> <hr> <div class="option-row"> <label>Select a new pivot table layout option below: </label></div> <div class="option-row"> <select id="layoutType"> <option value="0">Compact Form</option> <option value="1" selected>Outline Form</option> <option value="2">Tabular Form</option> </select> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 210px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 210px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }

피벗 테이블 레이아웃

SpreadJS 피벗 테이블에서는 압축 형식, 개요 형식 및 표 형식, 이렇게 3가지 종류의 레이아웃을 제공합니다. 레이아웃이 어떻게 바뀌는지 보기 위해 아래 데모에서 드롭다운 메뉴를 사용하여 레이아웃을 변경해 보십시오.

피벗 테이블에는 다음과 같이 3가지 레이아웃이 있습니다. 압축 형식 개요 형식 표 형식 기본 레이아웃은 압축 형식입니다. 각 레이아웃 유형에 대한 설명은 다음과 같습니다. 압축 형식 1.행 레이블 압축 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 각 행 레이블은 필드와 구분하기 위해 위에 있는 필드보다 약간 들여쓰기됩니다. 행 레이블은 반복할 수 없습니다. 들여쓰기는 레이아웃 및 서식 탭의 피벗 테이블 옵션에서 변경할 수 있습니다. 2.행 필드 압축 형식에서 모든 행 필드는 단일 열에 있습니다. 행 필드 열에는 일반 제목인 행 레이블이 있습니다. 3.부분합 압축 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 부분합이 맨 아래에 표시되더라도 행 레이블은 맨 위에 있습니다. 개요 형식 1.행 레이블 개요 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 개요 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 개요 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 표 형식 1.행 레이블 표 형식에서 외부 필드에 대한 행 레이블은 관련 내부 필드에 대한 첫 번째 레이블과 동일한 행에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 표 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 표 형식에서 부분합은 각 그룹의 맨 위에만 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 사용자는 피벗 테이블의 레이아웃 유형을 가져와 설정할 수 있습니다. PivotTableLayoutType은 아래와 같이 정의된 열거입니다.
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import './styles.css'; import '@mescius/spread-sheets-resources-ko'; GC.Spread.Common.CultureManager.culture("ko-kr"); @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { spread: GC.Spread.Sheets.Workbook; pt: any; hostStyle = { width: 'calc(100% - 210px)', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { this.spread = $event.spread; let spread = this.spread; this.initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); let pt = this.initPivotTable(pivotLayoutSheet); this.pt = pt; } initSheets(spread: GC.Spread.Sheets.Workbook) { spread.suspendPaint(); let sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); let sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); } initPivotTable(sheet: GC.Spread.Sheets.Worksheet) { let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Date", GC.Spread.Pivot.PivotTableFieldType.columnField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc }); let style = new GC.Spread.Sheets.Style(); style.formatter = "$ #,##0"; myPivotTable.setStyle({dataOnly: true}, style); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); return myPivotTable; } switchLayoutType(event: any) { let spread = this.spread; if (spread) { let type = parseInt(event.target.value, 10); this.pt.layoutType(type); this.pt.autoFitColumn(); } } } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule {} enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- Polyfills --> <script src="$DEMOROOT$/ko/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/ko/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/ko/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/ko/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> <gc-worksheet> </gc-worksheet> <gc-worksheet> </gc-worksheet> </gc-spread-sheets> <div class="options-container"> <div class="option-row"> <label><b>Pivot Layout</b> </label></div> <hr> <div class="option-row"> <label>Select a new pivot table layout option below: </label></div> <div class="option-row"> <select id="layoutType" (change)="switchLayoutType($event)"> <option value="0">Compact Form</option> <option value="1" selected>Outline Form</option> <option value="2">Tabular Form</option> </select> </div>    </div>  </div>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 210px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 210px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

피벗 테이블 레이아웃

SpreadJS 피벗 테이블에서는 압축 형식, 개요 형식 및 표 형식, 이렇게 3가지 종류의 레이아웃을 제공합니다. 레이아웃이 어떻게 바뀌는지 보기 위해 아래 데모에서 드롭다운 메뉴를 사용하여 레이아웃을 변경해 보십시오.

피벗 테이블에는 다음과 같이 3가지 레이아웃이 있습니다. 압축 형식 개요 형식 표 형식 기본 레이아웃은 압축 형식입니다. 각 레이아웃 유형에 대한 설명은 다음과 같습니다. 압축 형식 1.행 레이블 압축 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 각 행 레이블은 필드와 구분하기 위해 위에 있는 필드보다 약간 들여쓰기됩니다. 행 레이블은 반복할 수 없습니다. 들여쓰기는 레이아웃 및 서식 탭의 피벗 테이블 옵션에서 변경할 수 있습니다. 2.행 필드 압축 형식에서 모든 행 필드는 단일 열에 있습니다. 행 필드 열에는 일반 제목인 행 레이블이 있습니다. 3.부분합 압축 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 부분합이 맨 아래에 표시되더라도 행 레이블은 맨 위에 있습니다. 개요 형식 1.행 레이블 개요 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 개요 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 개요 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 표 형식 1.행 레이블 표 형식에서 외부 필드에 대한 행 레이블은 관련 내부 필드에 대한 첫 번째 레이블과 동일한 행에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 표 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 표 형식에서 부분합은 각 그룹의 맨 위에만 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 사용자는 피벗 테이블의 레이아웃 유형을 가져와 설정할 수 있습니다. PivotTableLayoutType은 아래와 같이 정의된 열거입니다.
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> <gc-worksheet> </gc-worksheet> <gc-worksheet> </gc-worksheet> </gc-spread-sheets> <div class="options-container"> <div class="option-row"> <label><b>Pivot Layout</b> </label></div> <hr> <div class="option-row"> <label>Select a new pivot table layout option below: </label></div> <div class="option-row"> <select id="layoutType" @change="switchLayoutType($event)"> <option value="0">Compact Form</option> <option value="1" selected>Outline Form</option> <option value="2">Tabular Form</option> </select> </div> </div> </div> </template> <script> import Vue from 'vue'; import '@mescius/spread-sheets-vue' import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import './styles.css'; import '@mescius/spread-sheets-resources-ko'; GC.Spread.Common.CultureManager.culture("ko-kr"); let App = Vue.extend({ name: "app", data: function () { return { spread: null, pt: null }; }, methods: { initSpread: function (spread) { this.spread = spread; this.initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); let pt = this.initPivotTable(pivotLayoutSheet); this.pt = pt; }, initSheets: function (spread) { spread.suspendPaint(); let sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); let sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); }, initPivotTable: function (sheet) { let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Date", GC.Spread.Pivot.PivotTableFieldType.columnField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc }); let style = new GC.Spread.Sheets.Style(); style.formatter = "$ #,##0"; myPivotTable.setStyle({dataOnly: true}, style); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); return myPivotTable; }, switchLayoutType: function (e) { let spread = this.spread; if (spread) { let type = parseInt(e.target.value, 10); this.pt.layoutType(type); this.pt.autoFitColumn(); } } } }); new Vue({ render: h => h(App) }).$mount('#app'); </script>
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- SystemJS --> <script src="$DEMOROOT$/ko/vue/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app.vue'); System.import('$DEMOROOT$/ko/lib/vue/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 210px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 210px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' }, '*.vue': { loader: 'vue-loader' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'css': 'npm:systemjs-plugin-css/css.js', 'vue': 'npm:vue/dist/vue.min.js', 'vue-loader': 'npm:systemjs-vue-browser/index.js', 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' } } }); })(this);

피벗 테이블 레이아웃

SpreadJS 피벗 테이블에서는 압축 형식, 개요 형식 및 표 형식, 이렇게 3가지 종류의 레이아웃을 제공합니다. 레이아웃이 어떻게 바뀌는지 보기 위해 아래 데모에서 드롭다운 메뉴를 사용하여 레이아웃을 변경해 보십시오.

피벗 테이블에는 다음과 같이 3가지 레이아웃이 있습니다. 압축 형식 개요 형식 표 형식 기본 레이아웃은 압축 형식입니다. 각 레이아웃 유형에 대한 설명은 다음과 같습니다. 압축 형식 1.행 레이블 압축 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 각 행 레이블은 필드와 구분하기 위해 위에 있는 필드보다 약간 들여쓰기됩니다. 행 레이블은 반복할 수 없습니다. 들여쓰기는 레이아웃 및 서식 탭의 피벗 테이블 옵션에서 변경할 수 있습니다. 2.행 필드 압축 형식에서 모든 행 필드는 단일 열에 있습니다. 행 필드 열에는 일반 제목인 행 레이블이 있습니다. 3.부분합 압축 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 부분합이 맨 아래에 표시되더라도 행 레이블은 맨 위에 있습니다. 개요 형식 1.행 레이블 개요 형식에서 각 행 레이블은 별도의 행에 있습니다. 행 필드 레이블은 항상 내부 필드에 대한 레이블 위에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 개요 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 개요 형식에서 부분합은 각 그룹의 맨 위 또는 맨 아래에 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 표 형식 1.행 레이블 표 형식에서 외부 필드에 대한 행 레이블은 관련 내부 필드에 대한 첫 번째 레이블과 동일한 행에 있습니다. 행 레이블은 반복할 수 있습니다. 2.행 필드 표 형식에서 각 행 필드는 별도의 열에 있습니다. 각 행 필드의 이름은 열 제목에 표시됩니다. 3.부분합 표 형식에서 부분합은 각 그룹의 맨 위에만 표시할 수 있습니다. 이 설정은 모든 행 필드에 영향을 미칩니다. 열 필드의 경우 부분합은 항상 맨 아래에 표시됩니다. 사용자는 피벗 테이블의 레이아웃 유형을 가져와 설정할 수 있습니다. PivotTableLayoutType은 아래와 같이 정의된 열거입니다.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; import '@mescius/spread-sheets-resources-ko'; GC.Spread.Common.CultureManager.culture("ko-kr"); const Component = React.Component; function _getElementById(id) { return document.getElementById(id); } class App extends Component { constructor(props) { super(props); this.spread = null; this.pt = null; } render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}> <Worksheet> </Worksheet> <Worksheet> </Worksheet> </SpreadSheets> </div> <Panel switchLayoutType={(e) => { this.switchLayoutType(e) }} /> </div> ); } initSpread(spread) { this.spread = spread; this.initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); let pt = this.initPivotTable(pivotLayoutSheet); this.pt = pt; } initSheets(spread) { spread.suspendPaint(); let sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); let sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); } initPivotTable(sheet) { let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Date", GC.Spread.Pivot.PivotTableFieldType.columnField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); myPivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); myPivotTable.sort("Cars", { sortType: GC.Pivot.SortType.asc }); let style = new GC.Spread.Sheets.Style(); style.formatter = "$ #,##0"; myPivotTable.setStyle({dataOnly: true}, style); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); return myPivotTable; } switchLayoutType(e) { let spread = this.spread; if (spread) { let type = parseInt(e.target.value, 10); this.pt.layoutType(type); this.pt.autoFitColumn(); } } } class Panel extends Component{ constructor(props){ super(props); } render(){ return( <div class="options-container"> <div class="option-row"> <label><b>Pivot Layout</b> </label></div> <hr /> <div class="option-row"> <label>Select a new pivot table layout option below: </label></div> <div class="option-row"> <select id="layoutType" onChange={(e)=>{this.props.switchLayoutType(e)}}> <option value="0">Compact Form</option> <option value="1" selected>Outline Form</option> <option value="2">Tabular Form</option> </select> </div> </div> ); } } ReactDOM.render(<App />, _getElementById('app'));
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- SystemJS --> <script src="$DEMOROOT$/ko/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/ko/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 210px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 210px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);